#Looking at Shakespeare-texts in the bag-of-letters space
#matrix
shakespeare<-read.table("/home/hans/relearn/Shakespeare_bag.csv",header=T, sep=",")
shakespeare2<-shakespeare[2:27]
head(shakespeare2)
shakespeare3<-data.matrix(shakespeare2)
#add rownames
rownames(shakespeare4)<-rownames(shakespeare4,do.NULL=FALSE,prefix="text.")

#normalise

shakesums=rowSums(shakespeare3)
shakesums
shakespeare4<-shakespeare3/rowSums(shakespeare3)
rowSums(shakespeare4) #test: everything=1


#principal components
model<-prcomp(shakespeare4,scale=TRUE)
summary(model)
biplot(model)

#multidimensional scaling
# Classical MDS
# N rows (objects) x p columns (variables)
# each row identified by a unique row name

d <- dist(shakespeare4) # euclidean distances between the rows
fit <- cmdscale(d,eig=TRUE, k=2) # k is the number of dim
fit # view results

# plot solution
x <- fit$points[,1]
y <- fit$points[,2]
plot(x, y, xlab="Coordinate 1", ylab="Coordinate 2",
     main="Metric MDS", type="n")
text(x, y, labels = row.names(shakespeare4), cex=.5) 
